/**
 * Copyright (C) 2017-2020 Linagora
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

html,
body,
app-root {
  width: 100%;
  height: 100%;
  margin: 0;
  padding: 0;
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  overflow: auto;
}

$sidebar-width: 360px;

mat-sidenav-container > mat-sidenav.mat-drawer-side {
  border-right-width: 1px;
  border-right-style: solid;
}

mat-sidenav-container > mat-sidenav-content.mat-drawer-content {
  margin-left: $sidebar-width;
}

app-material-tree {
  max-width: $sidebar-width;
}

mat-card-title.mat-card-title {
  font-size: 17px;
}

// with mat-table of material lib, the td padding is too high
// to reduce space, we prefer to use 12px rather than 24px
table.mat-table {
  tr > td.mat-cell:first-child,
  tr > td.mat-footer-cell:first-child,
  th.mat-header-cell:first-child {
    padding-left: 12px;
  }
  td.mat-cell:last-child,
  td.mat-footer-cell:last-child,
  th.mat-header-cell:last-child {
    padding-right: 12px;
  }
}

.mat-body-2 {
  margin-bottom: 4px;

  // fix angular material not correctly displaying bold text
  font-weight: bold;
}

.mat-snack-bar-container .wrapper-progress-bar {
  display: flex;
  align-items: baseline;
  justify-content: space-between;
}

body .text-upper {
  text-transform: uppercase;
}

.ellipsis {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

.card-auto-size {
  margin: 0 0 auto 0;
}

div > .mat-dialog-container {
  padding: 0;
  margin: 0;
}

.mat-tab-body-wrapper,
.mat-tab-body-content {
  height: 100%;
}

.wrapper-content {
  height: 100%;
  overflow: auto;
  background-image: url(./assets/img/gray_jean.png);
  background-size: auto;
  background-repeat: repeat;
  .central-content {
    width: 90%;
    max-width: 1000px;
    margin-left: auto;
    margin-right: auto;
  }
  @media screen and (max-width: 640px) {
    .central-content {
      width: 100%;
    }
  }
  .content {
    @extend .padding-x2;
  }
  @media screen and (max-width: 640px) {
    .content {
      padding: 10px;
    }
  }
  ngx-hover-opacity > div.content {
    @extend .padding-x0;
  }
}

.cursor-pointer:hover {
  cursor: pointer;
}

@font-face {
  font-family: Material Icons;
  font-style: normal;
  font-weight: 400;
  src: local(Material Icons), local(MaterialIcons-Regular);
}

.material-icons {
  font-family: 'Material Icons';
  font-weight: normal;
  font-style: normal;
  letter-spacing: normal;
  text-transform: none;
  display: inline-block;
  white-space: nowrap;
  word-wrap: normal;
  direction: ltr;
  font-feature-settings: 'liga';
  -webkit-font-feature-settings: 'liga';
  -webkit-font-smoothing: antialiased;
}

.form-error {
  color: red;
  font-size: 12px;
}

.italic {
  font-style: italic;
}

.break {
  word-break: break-all;
}

// custom scrollbar only for chrome
::-webkit-scrollbar {
  width: 5px;
  height: 10px;
  background-color: rgba(0, 0, 0, 0.07);
}
::-webkit-scrollbar:hover {
  background-color: rgba(0, 0, 0, 0.17);
}
::-webkit-scrollbar-corner {
  background-color: rgba(0, 0, 0, 0.17);
  border-left: 1px solid rgba(0, 0, 0, 0.17);
  border-top: 1px solid rgba(0, 0, 0, 0.17);
}
::-webkit-scrollbar-thumb {
  background: rgba(0, 0, 0, 0.5);
  box-shadow: 1px 1px 2px rgba(0, 0, 0, 0.2);
}
::-webkit-scrollbar:disabled {
  background-color: rgba(0, 0, 0, 0.03);
  width: 0px;
  height: 0px;
}
::-webkit-scrollbar-thumb:hover {
  background: rgba(0, 0, 0, 0.55);
}
::-webkit-scrollbar-thumb:active {
  background: rgba(0, 0, 0, 0.61);
}
::-webkit-scrollbar-track:vertical,
::-webkit-scrollbar-track:vertical:hover {
  border-left: 1px solid rgba(0, 0, 0, 0.17);
}
::-webkit-scrollbar-track:vertical:active {
  border-left: 1px solid rgba(0, 0, 0, 0.2);
}
::-webkit-scrollbar-track:horizontal,
::-webkit-scrollbar-track:horizontal:hover {
  border-top: 1px solid rgba(0, 0, 0, 0.17);
}
::-webkit-scrollbar-track:horizontal:active {
  border-top: 1px solid rgba(0, 0, 0, 0.2);
}

.prefix-toolbar-title {
  width: 20px;
  text-align: center;
}

.wrapper-content
  > .mat-tab-group
  > .mat-tab-header
  > .mat-tab-label-container
  > .mat-tab-list
  > .mat-tab-labels {
  .mat-tab-label {
    text-transform: uppercase;
    opacity: 1 !important;
  }
}

// customize toolbars
app-workspace > app-header > .toolbar > mat-toolbar,
app-administration > .wrapper-content > .toolbar > mat-toolbar,
app-user-profile > .wrapper-content > .toolbar > mat-toolbar {
  height: 64px;
  min-height: 64px;
}

app-header .toolbar-page-header,
.toolbar-page-header,
.admin-page > mat-toolbar.toolbar-page-header,
.admin-page > mat-toolbar.toolbar-page-header {
  height: 140px;
  min-height: 140px;
  h1.title {
    font-size: 30px;
    font-weight: 300;
    margin: 0;
    padding: 50px;
    white-space: pre-wrap;
  }
}

@media screen and (max-width: 840px) {
  app-header .toolbar-page-header,
  .toolbar-page-header,
  .admin-page > mat-toolbar.toolbar-page-header,
  .admin-page > mat-toolbar.toolbar-page-header {
    height: 80px;
    min-height: 80px;
    h1.title {
      padding: 24px 8px;
      font-size: 20px;
    }
  }
}

app-services-service-overview > .mat-nav-list > .mat-list-item > .item-name,
app-services-service-overview
  > .mat-nav-list
  > .mat-list-item
  > .item-localpart,
app-services-service-overview
  > .mat-nav-list
  > .mat-list-item
  > .item-namespace,
app-services-service-overview > .mat-list > .mat-list-item > .item-localpart,
app-services-service-overview > .mat-list > .mat-list-item > .item-namespace {
  word-break: break-all;
}

// all items elements in petals and services menu view
app-material-tree > .nav-list-tree > .item-list > .mat-list-item,
app-material-tree
  > .nav-list-tree
  > .item-list
  > .mat-list-item.mat-list-item-with-avatar {
  height: 24px;

  .item-content > .item-name {
    display: inline-block;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
  }
  .item-name {
    display: inline-block;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: clip;
  }

  .item-content > .arrow-size {
    width: 14px;
  }
}

// all items elements in petals and services menu view ref
// TODO: Remove above classes when mat-tree fully integrated
mat-tree {
  .mat-tree-node {
    min-height: 24px;
    height: 24px;
  }

  .element-info {
    width: 95%;
  }

  .workspace-element-name {
    margin-left: 5px;
    font-size: 12px;
  }

  .tree-element-name {
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
  }

  .tree-icon-svg {
    width: 20px;
  }

  .tree-icon {
    height: 19px;
    font-size: 19px;
  }

  .btn-node {
    background: transparent;
    outline: none;
    border: none;
  }

  .selected-element span {
    font-weight: bold;
  }

  [class^='.btn-expandable'] {
    width: 50px;
  }
}

.rotate-minus-90 {
  -ms-transform: rotate(-90deg);
  -webkit-transform: rotate(-90deg);
  transform: rotate(-90deg);
}

// this is changed to make tests pass
// overflow on parent makes content not visible
app-services-menu-view {
  .exp-pnl-interfaces-tree,
  .exp-pnl-services-tree,
  .exp-pnl-endpoints-tree {
    overflow: hidden;
  }
}

// use for all services trees component
app-services-menu-view > .services-menu-view > .pnl-services-trees {
  .mat-accordion > mat-expansion-panel > mat-expansion-panel-header {
    padding: 10px 12px 10px 10px;
  }
  .mat-accordion
    > mat-expansion-panel
    > .mat-expansion-panel-content
    > .mat-expansion-panel-body {
    padding: 0;
  }
}

// all items elements in petals tree
app-material-tree > .nav-list-tree > .item-list {
  // customize active elements
  .active-link,
  .active-link:hover {
    .mat-list-item-content,
    .mat-list-item-content:hover {
      @extend .color-primary-bold;
      margin: 0;
      border-left-width: 2px;
      border-left-style: solid;
    }
  }

  // customize namespace in tree services
  a.item-namespace > .mat-list-item-content,
  a.item-namespace > .mat-list-item-content:focus,
  a.item-namespace > .mat-list-item-content:hover {
    cursor: default;
  }

  // customize tree elements
  .mat-list-item > .mat-list-item-content {
    padding-left: 10px;
  }

  .mat-list-item > .mat-list-item-content:hover,
  .mat-list-item > .mat-list-item-content:focus {
    @extend .color-primary-light-bold;
  }
}

app-workspaces-list
  > div
  > .workspaces-list
  > .mat-list-item
  > .mat-list-item-content {
  padding: 16px 16px 6px;
}
